__doc__ = """\
: FloodGuard
: Tue Dec 18 12:38:16 MSK 2001
:    (c) 2001
c: $Id: FloodGuard.py,v 1.4 2002/03/01 12:15:58 cray Exp $

:
        FloodGuard.py

:
        ,     , 
	      
	.     ,  
	(+1-2 ),        
	IP-.        
	     ,  
	  ,     ,
	      
	 .

	       IIGFS,
	      .
"""
__version__ = '$Revision: 1.4 $'[8:-1]

from Globals import HTMLFile      
from Globals import MessageDialog 
from Globals import Persistent    
from Globals import default__class_init__

import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import Products

try :
	from Products.IIGFS.PropertyManager import PropertyManager
	from Products.IIGFS.ObjectManager import ObjectManager
	from Products.IIGFS.libIIGFS import libIIGFS_mixin
except :
	from OFS.PropertyManager import PropertyManager
	from ZClasses.ObjectManager import ObjectManager
	class libIIGFS_mixin :
	    def request_remote_ip(self,REQUEST) :
		"""  IP-  .  ,
		      ip.

		      allow_empty_ip, 
		   ip   REQUEST['REMOTE_ADDR']
		"""

		if REQUEST['REQUEST_METHOD'] == 'POST':
		        for attr,val in filter(lambda x : len(x)==2,map(lambda x : string.split(x,'=',1),string.split(REQUEST['QUERY_STRING'],'&'))) :
        		        if attr=='ip' :
                		        return val
		else :
			if REQUEST.form.has_key('ip')  :
				return REQUEST.form['ip']

		try :
			if self.allow_empty_ip :
				return REQUEST['REMOTE_ADDR']
		except AttributeError :
			return REQUEST['REMOTE_ADDR']
	
		raise 'UnknownIP',' IP-        '


from Products.SiteAccess.SiteRoot import Traverser

import re
import string
import time
manage_addFloodGuardForm = HTMLFile('dtml/FloodGuardAdd', globals()) 

FloodGuardBlocked = 'FloodGuardBlocked'
FloodGuardReferer = 'FloodGuardReferer'

def manage_addFloodGuard(self, id, title=None, REQUEST=None):
    """  FloodGuard """
    ob = FloodGuard(id)
    self._setObject(id, ob)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


FloodGuardData = {}

class FloodGuard(
    libIIGFS_mixin,
    Traverser,
    PropertyManager,
    ObjectManager,
    OFS.SimpleItem.Item,   
    Persistent,            
    Acquisition.Implicit,  
    AccessControl.Role.RoleManager 
    ): 
    """   ,  
      : 

	<URL  REGEXP> <> <> <> < >,

             ,
        ."""
        
    meta_type = 'FloodGuard' 

# PropertyManager.manage_options
    manage_options =  ( 
	{'label': '',       		'action': 'manage_propertiesForm', 	'help':('FloodGuard','FloodGuard_Properties.stx')},
#	   
#	{'label': '',         	'action': 'manage_main',		'help':('FloodGuard','FloodGuard_Contents.stx')},
	{'label': ' ',         	'action': 'manage_logs',		'help':('FloodGuard','FloodGuard_Logs.stx')},
    ) 

    use_floodguard = ''
    use_floodguard_checks = 'on'
    use_regexp = 'on'
    use_pathid = 'on'
    use_on_exist_key = 'on'
    use_rejected_log = 'on'
    use_referer = ''
    clean_skip	= 100
    requests = []
    fuck_name = ''
    fun_log = 'internal_log'
    fun_add = 'internal_add'
    fun_check = 'internal_check'
    fun_clean = 'internal_clean'
    regexps = []
    pars = {}

    _properties = PropertyManager._properties + (
        {'id':'use_floodguard', 	'name':'', 		'type':'boolean', 	'mode':'w'},
        {'id':'use_floodguard_checks', 	'name':'  ', 		'type':'boolean', 	'mode':'w'},
        {'id':'use_regexp', 	'name':' RegExp', 	'type':'boolean', 	'mode':'w'},
        {'id':'use_pathid', 	'name':' ','type':'boolean', 	'mode':'w'},
        {'id':'use_on_exist_key', 'name':'  ','type':'boolean', 	'mode':'w'},
        {'id':'use_rejected_log', 'name':'  ','type':'boolean', 	'mode':'w'},
        {'id':'use_referer', 	'name':' HTTP_REFERER','type':'boolean', 	'mode':'w'},
        {'id':'clean_skip', 	'name':'   ', 'type':'int', 	'mode':'w'},
        {'id':'fuck_name', 	'name':' ', 	'type':'string', 	'mode':'w'},
	{'id':'requests', 	'name':' ',	'type':'lines', 	'mode':'w'},
#    
#	{'id':'fun_log',	'name':' ',	'type':'selection',	'mode':'w',	'select_variable':'list_log' },
#	{'id':'fun_add',	'name':' ',	'type':'selection',	'mode':'w',	'select_variable':'list_add' },
#	{'id':'fun_check',	'name':' ',	'type':'selection',	'mode':'w',	'select_variable':'list_check' },
#	{'id':'fun_clean',	'name':' ',	'type':'selection',	'mode':'w',	'select_variable':'list_clean' },
    )

    def __init__(self, id, title='') :  
        """initialise a new instance of FloodGuard"""
        self.id = id
        self.title = title
	self.requests  = ['manage_[^/]*$ 60 10 _ ']

    def list_log(self) :
	return ('internal_log',) + self.objectIds()

    def list_add(self) :
	return ('internal_add',) + self.objectIds()

    def list_check(self) :
	return ('internal_check',) + self.objectIds()

    def list_clean(self) :
	return ('internal_clean',) + self.objectIds()

    def internal_storage(self) :
	try :
		return FloodGuardData[self.absolute_url(1)]
	except KeyError :
		FloodGuardData[self.absolute_url(1)] = tmp = {}
		return tmp

    manage_logs = HTMLFile('dtml/FloodGuardLog', globals()) 

    def internal_log(self) :
	as = []
	for a,vs in self.internal_storage().items() :
		for v in vs :
			as.append((v,)+a)
	as.sort()
	as.reverse()
	return map(lambda x : { 'id':x[1],'key':str(x[2]),'ipaddr':x[3], 'time':time.asctime(time.localtime(x[0])) },as)

    def internal_add(self,id,ids,ip) :
		stor = self.internal_storage()
		t = time.time()
		try :
			stor[(id,ids,ip)].insert(0,time.time())
		except KeyError :
			stor[(id,ids,ip)] = [time.time()]

    def internal_check(self,id,ids,ip,period,count) :
		stor = self.internal_storage()
		t = time.time()
		try :
			lst = stor[(id,ids,ip)]
			t1 = lst[count]
		except KeyError :
			self.REQUEST['CALL_COUNT'] = 0
			return 1

		except IndexError :
			self.REQUEST['CALL_COUNT'] = len(lst)
			return 1

		self.REQUEST['CALL_COUNT'] = len(lst)
		return (t-period) > t1

    def internal_clean(self,id,ids,ip,period,count) :
		stor = self.internal_storage()
		t = time.time()
		for a,v in stor.items() :
			if v[0] < (t - period) :
				del(stor[a])

    def discard(self,item,period,n) :
	s = string.strip(self.fuck_name)
	if s :
	    try :
		method = self.restrictedTraverse(s)
	    except AttributeError :
		raise FloodGuardBlocked,' %s    %u   %u ,   %s -  ' % (item, n, period,s)
	    else :
		raise FloodGuardBlocked,method(self.getPhysicalRoot(),self.REQUEST)##method,
	raise FloodGuardBlocked,' %s    %u   %u ' % (item, n, period)

    def checks_url(self,url=None) :
	#       
	if self.use_floodguard_checks :
		return self.checks(self.REQUEST['PATH_TRANSLATED'],url,self.pars[url])

    def checks(self,path,url,(period,count,id,vars)) :
		ids = []
		for item in vars :
			try :
				ids.append(self.REQUEST[item])
			except KeyError :
				if self.use_on_exist_key :
					return 1
				ids.append(None)

		if self.use_referer :
			try :
				referer = string.split(self.REQUEST['HTTP_REFERER'],'/')[2]
				host = self.REQUEST['HTTP_HOST']
				if referer != host :
					raise FloodGuardReferer,' %s       %s' % (url,referer)
			except IndexError :
				raise FloodGuardReferer,' %s       ' % (url,)
			except KeyError :
				pass

		ids = tuple(ids)
		if self.use_pathid :
			id = url
				
		ip = self.request_remote_ip(self.REQUEST)

		if not self.internal_check(id,ids,ip,period,count) :
			if self.use_rejected_log :			
				self.internal_add(id,ids,ip) 
			return self.discard(path,period,count)
		else :
			self.internal_add(id,ids,ip) 

		try :
			self._v_clean_skip = self._v_clean_skip - 1
		except AttributeError :
			self._v_clean_skip = self.clean_skip

		if self._v_clean_skip <= 0 :
			self._v_clean_skip = self.clean_skip
			self.internal_clean(id,ids,ip,period,count)

		return

    def __call__(self,client,REQUEST,RESPONSE=None) :
	if self.use_floodguard :
		path = self.REQUEST['PATH_TRANSLATED']
		if self.use_regexp :
			n = 0
			for search in self.regexps :
				res = search.search(path)
				if res :
					return self.checks(path,res.group(0),self.pars[n])
				n = n + 1
		else :
			if self.pars.has_key(path) :
				return self.checks(path,path,self.pars[path])
    
    def compile(self) :
		self.regexps = []
		self.pars = {}
		for item in self.requests :
  		   if string.strip(item) :
			url,period,count,id,vars = string.split(item,' ',4)
			vars = string.split(vars)
			pars = (int(period),int(count),id,tuple(vars))
			self.pars[url] = pars
			if self.use_regexp :
				self.pars[len(self.regexps)] = pars
				self.regexps.append(re.compile(url))

    def manage_editProperties(self, REQUEST=None, **kw) :
	"""  """
	try :
		res = apply(PropertyManager.manage_editProperties,(self,REQUEST),kw)
	finally :
		self.compile()
	return res

default__class_init__ (FloodGuard)
